package org.my.helloworld;

import java.util.Dictionary;

import org.cishell.framework.CIShellContext;
import org.cishell.framework.algorithm.Algorithm;
import org.cishell.framework.algorithm.AlgorithmExecutionException;
import org.cishell.framework.data.Data;
import org.osgi.service.log.LogService;

public class HelloWorldAlgorithm implements Algorithm {
    private Data[] data;
    private Dictionary parameters;
    private CIShellContext ciShellContext;
	private LogService logger;
    
    public HelloWorldAlgorithm(Data[] data,
    				  Dictionary parameters,
    				  CIShellContext ciShellContext) {
        this.data = data;
        this.parameters = parameters;
        this.ciShellContext = ciShellContext;
        this.logger = (LogService) ciShellContext.getService(LogService.class.getName());
    }

    public Data[] execute() throws AlgorithmExecutionException {
    	String name = (String) parameters.get("name");
    	this.logger.log(LogService.LOG_INFO, "Hello World!\n Welcome " + name);
		this.logger.log(LogService.LOG_WARNING, "Warning msg");
		this.logger.log(LogService.LOG_ERROR, "Error msg");
		this.logger.log(LogService.LOG_DEBUG, "Debug msg");
        return null;
    }
}