package org.my.helloworld.fromfile;

import java.util.Dictionary;
import java.util.Iterator;

import org.cishell.framework.CIShellContext;
import org.cishell.framework.algorithm.Algorithm;
import org.cishell.framework.algorithm.AlgorithmExecutionException;
import org.cishell.framework.data.Data;
import org.osgi.service.log.LogService;

import prefuse.data.Table;

public class HelloWorldFromFileAlgorithm implements Algorithm {
    private Data[] data;
    private Dictionary parameters;
    private CIShellContext ciShellContext;
	private LogService logger;
	private String nameColumnTitle;
	private Integer favorNumberValue;
    
    public HelloWorldFromFileAlgorithm(Data[] data,
    				  Dictionary parameters,
    				  CIShellContext ciShellContext) {
        this.data = data;
        this.parameters = parameters;
        this.ciShellContext = ciShellContext;
        this.logger = (LogService) ciShellContext.getService(LogService.class.getName());
        this.nameColumnTitle = parameters.get("name").toString();
        this.favorNumberValue = Integer.valueOf(parameters.get("favor").toString());
    }

    public Data[] execute() throws AlgorithmExecutionException {
    	
    	Table inputTable = (Table) data[0].getData();
    	Iterator<?> rowsIterator = inputTable.iterator();
    	Integer nameColumnIndex = inputTable.getColumnNumber(nameColumnTitle);
    	
		while (rowsIterator.hasNext()) {
			int currentRowNumber = Integer.parseInt(rowsIterator.next().toString());
			String name = (String) inputTable.get(currentRowNumber, nameColumnIndex);
			this.logger.log(LogService.LOG_INFO, name);
			this.logger.log(LogService.LOG_INFO, favorNumberValue.toString());
		}
		return null;
    }
}